aboutsummaryrefslogtreecommitdiffstats
path: root/contrib/git-stats.sh
diff options
context:
space:
mode:
authorRobin Jarry <robin@jarry.cc>2022-10-18 23:59:34 +0200
committerRobin Jarry <robin@jarry.cc>2022-10-20 00:29:16 +0200
commitdf1a0fff33b920ed2827cc376eb781a737ff7685 (patch)
treee20e1a65ef4ca2b458329940ac610a1eef41a051 /contrib/git-stats.sh
parent41c14b206c83197c5095faf47be2d8eb04386a92 (diff)
downloadaerc-df1a0fff33b920ed2827cc376eb781a737ff7685.tar.gz
contrib: add git-stats.sh
git shortlog -sn is nice but it does not display the number of changed files and the amount of changed lines. $ git shortlog -sn 0.12.0.. 46 Tim Culverhouse 28 Robin Jarry 14 Koni Marti 9 Moritz Poldrack 2 Ben Cohen 2 Bence Ferdinandy 2 Julian Pidancet 2 inwit 1 Jason Cox 1 Jason Stewart 1 John Gebbie 1 Tobias Wölfel 1 kt programs Add a simple bash script that adds extra information: $ ./contrib/git-stats.sh 0.12.0.. Author Commits Changed Files Insertions Deletions Tim Culverhouse 46 134 +973 -1090 Robin Jarry 28 70 +671 -358 Koni Marti 14 47 +437 -205 Moritz Poldrack 9 18 +178 -44 Ben Cohen 2 2 +16 -2 Bence Ferdinandy 2 6 +104 +0 Julian Pidancet 2 9 +149 -2 inwit 2 3 +11 -1 Jason Cox 1 7 +106 -6 Jason Stewart 1 1 +4 -2 John Gebbie 1 3 +118 -1 Tobias Wölfel 1 3 +3 -3 kt programs 1 3 +37 -6 Use the script to generate the release tag and email. Signed-off-by: Robin Jarry <robin@jarry.cc> Acked-on-irc-by: Tim Culverhouse <tim@timculverhouse.com>
Diffstat (limited to 'contrib/git-stats.sh')
-rwxr-xr-xcontrib/git-stats.sh23
1 files changed, 23 insertions, 0 deletions
diff --git a/contrib/git-stats.sh b/contrib/git-stats.sh
new file mode 100755
index 00000000..735817a1
--- /dev/null
+++ b/contrib/git-stats.sh
@@ -0,0 +1,23 @@
+#!/bin/bash
+
+set -e
+set -o pipefail
+
+columns="Author,Commits,Changed Files,Insertions,Deletions"
+
+git shortlog -sn "$@" |
+while read -r commits author; do
+ git log --author="$author" --pretty=tformat: --numstat "$@" | {
+ adds=0
+ subs=0
+ files=0
+ while read -r a s f; do
+ adds=$((adds + a))
+ subs=$((subs + s))
+ files=$((files + 1))
+ done
+ printf '%s;%d;%d;%+d;%+d;\n' \
+ "$author" "$commits" "$files" "$adds" "-$subs"
+ }
+done |
+column -t -s ';' -N "$columns" -R "${columns#*,}"